/* cl sime.c */
#include <windows.h>
#include <windowsx.h>
#include <tchar.h>
#include "sime.rh"
#include "simereg.h"
#include "simeregm.h"

#ifdef _MSC_VER
#pragma comment(linker, "/SUBSYSTEM:WINDOWS")
#pragma comment(linker, "/DEFAULTLIB:kernel32.lib")
#pragma comment(linker, "/DEFAULTLIB:user32.lib")
#pragma comment(linker, "/DEFAULTLIB:shell32.lib")
#pragma comment(linker, "/DEFAULTLIB:advapi32.lib")
#pragma comment(linker, "/HEAP:0 /STACK:0x1000")
#pragma comment(linker, "/ENTRY:MyExeEntry")
#if _MSC_VER >= 1200
#pragma comment(linker, "/OPT:NOWIN98")
/* #pragma comment(linker, "/WS:AGGRESSIVE") */
#endif
#endif

#define KEYBOARDDLLFILE		_TEXT("SIMESUB.DLL")
#define WM_TRAYICON (WM_USER + 200)
#ifdef _UNICODE
#define NOTIFYFUNCNAME		"Shell_NotifyIconW"
#else
#define NOTIFYFUNCNAME		"Shell_NotifyIconA"
#endif

static HHOOK hHook = NULL ;			// L[{[htbNnh
static HMODULE hHookDll = NULL ;	// L[{[htbNDLL̃nh

// ACR쐬
static HMODULE hDllShell32 = NULL ;
typedef BOOL (__stdcall *pShell_NotifyIcon)(DWORD dwMessage, PNOTIFYICONDATA pnid) ;
static pShell_NotifyIcon Shell_NotifyIconFunc ;
static NOTIFYICONDATA nid ;
static BOOL TrayIconInstall(HINSTANCE hInstance)
{
	HWND hWnd ;
	int ws ;
	hDllShell32 = LoadLibrary(_TEXT("SHELL32.DLL")) ;
	if (NULL != hDllShell32)
	{
		Shell_NotifyIconFunc = (pShell_NotifyIcon)GetProcAddress(hDllShell32, NOTIFYFUNCNAME) ;
		if (NULL == Shell_NotifyIconFunc)
		{
			FreeLibrary(hDllShell32) ;
			hDllShell32 = NULL ;
		}
	}
	if (NULL != hDllShell32)
	{
		ws = WS_OVERLAPPED ;
	} else {
		ws = WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU ;
	}
	// ^XNgCACRp_~[EChE
	hWnd = CreateWindow(
		TASKTRAYICONCLASS,		// EChENX
		TASKTRAYICONNAME,		// EChE^Cg
		ws,						// EChĚ`
		0,						// x1
		0,						// y1
		0,						// x2
		0,						// y2
		NULL,					// eEChE͂Ȃ
		NULL,					// j[Ȃ
		hInstance,				// EChEǗCX^X
		NULL					// ǉȂ
	) ;
	if (NULL != hDllShell32)
	{
		ShowWindow(hWnd, SW_HIDE) ;
		UpdateWindow(hWnd) ;
		nid.cbSize = sizeof(NOTIFYICONDATA) ;
		nid.uID = 1 ;
		nid.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_MAINICON)) ;
		nid.hWnd = hWnd ;	// bZ[WʒmEChE
		lstrcpy(nid.szTip, _TEXT("SwitchIME")) ;	// ^XNgC`bvwv
		nid.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP ;
		nid.uCallbackMessage = WM_TRAYICON ;
		Shell_NotifyIconFunc(NIM_ADD, &nid) ;
	} else {
		HMENU hMenu ;
		hMenu = GetSystemMenu(hWnd, FALSE) ;
		//DeleteMenu(hMenu, SC_RESTORE, MF_BYCOMMAND) ;
		AppendMenu(hMenu, MF_SEPARATOR, 0, 0) ;
		AppendMenu(hMenu, MF_STRING, IDM_ABOUT, _TEXT("o[W(&A)")) ;
		ShowWindow(hWnd, SW_SHOWMINNOACTIVE) ;
		UpdateWindow(hWnd) ;
	}
    return TRUE ;
}
// ^XNgCACRj
static void TrayIconUninstall(void)
{
	if (NULL != hDllShell32)
	{
		Shell_NotifyIconFunc(NIM_DELETE, &nid) ;
		FreeLibrary(hDllShell32) ;
		hDllShell32 = NULL ;
	}
}
// ݒXV
static void KeySetupUpdate(void)
{
	KEYINFO kinfo[64] ;
	int i ;
	HOOKPROC hookProc ;
	if (NULL == hHookDll) return ;
	hookProc = (HOOKPROC)GetProcAddress(hHookDll, "KeyBoardHookProc") ;
	if (NULL == hookProc) return ;
	SIME_LoadRegistory(kinfo) ;
	for (i = 0 ; i < 63 ; i++) {
		if (kinfo[i].code == 0) break ;
		hookProc(0x7fff, i | (kinfo[i].flag << 8), kinfo[i].code) ;
	}
}

// L[{[htbNݒ肷
static BOOL KeyBoardHookInstall(void)
{
	HOOKPROC hookProc ;
	hHookDll = LoadLibrary(KEYBOARDDLLFILE) ;
	if (NULL == hHookDll) return FALSE ;
	hookProc = (HOOKPROC)GetProcAddress(hHookDll, "KeyBoardHookProc") ;
	if (NULL == hookProc) return FALSE ;
	hHook = SetWindowsHookEx(WH_KEYBOARD, hookProc, hHookDll, 0) ;
	if (NULL == hHook) return FALSE ;
	hookProc(0x7fff, 0xffffffff, (LPARAM)hHook) ;
	KeySetupUpdate() ;
	return TRUE ;
}

// L[{[htbN
static void KeyBoardHookUninstall(void)
{
	if (hHook != NULL) UnhookWindowsHookEx(hHook) ;
	if (hHookDll != NULL) FreeLibrary(hHookDll) ;
}
// ɋNĂ邩ׂ
static BOOL CheckExist(void)
{
	return (NULL != FindWindow(TASKTRAYICONCLASS, TASKTRAYICONNAME)) ;
}
// I
static void SimeClose(void)
{
	// L[{[htbN
	KeyBoardHookUninstall() ;
	// ^XNgCACRj
	TrayIconUninstall() ;
}
// EChE֐(VXe烁bZ[W󂯎)
LRESULT __stdcall TasktrayIconProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message) {
	case WM_USER:
		KeySetupUpdate() ;
		break ;
	case WM_INITMENU:
		EnableMenuItem((HMENU)wParam, SC_RESTORE, MF_BYCOMMAND | MF_GRAYED) ;
		break ;
	case WM_SIZE:
		return 0 ;
	case WM_SYSCOMMAND:
	case WM_COMMAND:
		switch (GET_WM_COMMAND_ID(wParam, lParam)) {
		case SC_RESTORE:
			return 0 ;
		case IDM_ABOUT:
			MessageBox(NULL,_TEXT("SwitchIME version 0.03\nCopyright (c)1997-2000 Mao"),_TEXT("About..."),MB_OK) ;
			break ;
		case IDM_EXIT:
			// j[ I [U[I
			PostMessage(hWnd, WM_CLOSE, 0, 0L) ;
			break ;
		case IDM_SETUP:
			WinExec("SIMECNFG.EXE", SW_SHOW) ;
			break ;
		}
		break ;
	case WM_TRAYICON:
		// gCACȐ
		switch(lParam)
		{
			HMENU hMenu ;
			POINT pt ;
		case WM_LBUTTONDOWN:
		case WM_RBUTTONDOWN:
			//PostMessage(hWnd, WM_CLOSE, 0, 0L) ;
			if (NULL == (hMenu = CreatePopupMenu())) break ;
			GetCursorPos(&pt) ;
			SetForegroundWindow(hWnd) ;
			AppendMenu(hMenu, MF_STRING, IDM_ABOUT, _TEXT("o[W(&A)")) ;
			AppendMenu(hMenu, MF_STRING, IDM_SETUP, _TEXT("ݒ")) ;
			AppendMenu(hMenu, MF_SEPARATOR, 0, 0) ;
			AppendMenu(hMenu, MF_STRING, IDM_EXIT, _TEXT("(&C)")) ;
			TrackPopupMenu(hMenu, TPM_RIGHTALIGN, pt.x, pt.y, 0, hWnd, NULL) ;
			DestroyMenu(hMenu) ;
			break ;
		}
		break ;
	case WM_CLOSE:
		// EChEYɃEChEj悤ɓ`
		DestroyWindow(hWnd) ;
		return 0L ;
	case WM_DESTROY:
		// DestroyWindow ĂяoɂI̍}
		SimeClose() ;
		PostQuitMessage(0) ;	// ŏI
		return 0L ;
	case WM_QUERYENDSESSION:
		// TRUE ԂƁC̃EBhEỸZbVI点
		// 悢ƂӖɂȂ
		SimeClose() ;
		return (long)TRUE ;	// ŏI
	}
	return DefWindowProc(hWnd, message, wParam, lParam) ;
}

// ̃AvP[ṼEChENX`
static BOOL RegisterWindowClass(HINSTANCE hInstance, HINSTANCE hPrevInstance)
{
	WNDCLASS wc ;
	if (NULL != hPrevInstance) return TRUE ;
	wc.lpszClassName	= TASKTRAYICONCLASS ;
	wc.hInstance		= hInstance ;
	wc.lpfnWndProc		= TasktrayIconProc ;
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW) ;
	wc.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_MAINICON)) ;
	wc.lpszMenuName		= NULL ;
	wc.hbrBackground	= (HBRUSH)(COLOR_WINDOW + 1) ;
	wc.style			= CS_HREDRAW | CS_VREDRAW ;
	wc.cbClsExtra		= 0 ;
	wc.cbWndExtra		= 0 ;
	if (0 == RegisterClass(&wc)) return FALSE ;	// NXo^
	return TRUE ;
}

int __stdcall WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int cmdShow)
{
	MSG msg ;
	// ɋNĂȂI
	if (CheckExist()) return 0 ;
	// ̃AvP[ṼEChENX`
	if (!RegisterWindowClass(hInstance, hPrevInstance)) return 0 ;
	// ACR쐬
	if (!TrayIconInstall(hInstance)) return 0 ;
	// L[{[htbNݒ肷
	if (!KeyBoardHookInstall()) {
		TrayIconUninstall() ;
		return 0 ;
	}
	// ̃AvP[Vւ̃bZ[W̎擾ƁC̏
	while (GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg) ;
		DispatchMessage(&msg) ;
	}
	return (msg.wParam) ;
}

void MyExeEntry(void) {
	ExitProcess(WinMain(GetModuleHandle(NULL), NULL, NULL, SW_SHOWDEFAULT)) ;
}
