/* cl simecnfg.c */
#include <windows.h>
#include <windowsx.h>
#include <ime.h>
#include <tchar.h>
#include "sime.rh"
#include "simereg.h"
#include "simeregm.h"

#ifdef _MSC_VER
#pragma comment(linker, "/SUBSYSTEM:WINDOWS")
#pragma comment(linker, "/DEFAULTLIB:kernel32.lib")
#pragma comment(linker, "/DEFAULTLIB:user32.lib")
#pragma comment(linker, "/DEFAULTLIB:shell32.lib")
#pragma comment(linker, "/DEFAULTLIB:advapi32.lib")
#pragma comment(linker, "/HEAP:0 /STACK:0x1000")
#pragma comment(linker, "/ENTRY:MyExeEntry")
#if _MSC_VER >= 1200
#pragma comment(linker, "/OPT:NOWIN98")
/* #pragma comment(linker, "/WS:AGGRESSIVE") */
#endif
#endif

#if 1
#define DOUT(p1,p2)
#else
static void _DOUT(char *format, int value) {
	char buf[256] ;
	wsprintf(buf,format,value) ;
	OutputDebugString(buf) ;
}
#define DOUT(p1,p2) _DOUT(p1,p2);
#endif

static KEYINFO kinfo[64] ;

int GetKeyFlag(KEYINFO *buf, int y) {
	int i ;
	static unsigned int vkeytbl[4] = {VK_CONVERT, VK_NONCONVERT, VK_DBE_SBCSCHAR, SCAN_FLAG|0x138} ;
	for (i = 0; i < 63; i++) {
		if (buf[i].code == 0) break ;
		if (buf[i].code == vkeytbl[y]) return buf[i].flag ;
	}
	return 0 ;
}
void SetKeyFlagSub(KEYINFO *buf, int flag, unsigned int vkey) {
	int i ;
	for (i = 0; i < 63; i++) {
		if (buf[i].code == 0) {
			buf[i+1].code = 0 ;
			buf[i].flag = flag ;
			buf[i].code = vkey ;
			return ;
		}
		if (buf[i].code == vkey) {
			buf[i].flag = flag ;
			return ;
		}
	}
	return ;
}
void SetKeyFlag(KEYINFO *buf, int flag, int y) {
	switch(y) {
	case 0:
		SetKeyFlagSub(buf, flag, VK_CONVERT) ;
		break ;
	case 1:
		SetKeyFlagSub(buf, flag, VK_NONCONVERT) ;
		break ;
	case 2:
		SetKeyFlagSub(buf, flag, VK_DBE_SBCSCHAR) ;
		SetKeyFlagSub(buf, flag, VK_DBE_DBCSCHAR) ;
		break ;
	case 3:
		SetKeyFlagSub(buf, flag, SCAN_FLAG|0x138) ;
		break ;
	}
}

BOOL __stdcall SetupDialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	if (uMsg == WM_INITDIALOG) {
		// ʂ̒Ɉړ
		RECT rc ;
		int wscreen, hscreen, id, i ;
		wscreen = GetSystemMetrics(SM_CXSCREEN) ;
		hscreen = GetSystemMetrics(SM_CYSCREEN) ;
		GetWindowRect(hwndDlg, &rc) ;
		SetWindowPos(hwndDlg, NULL,
			(wscreen - (rc.right - rc.left))/2,
			(hscreen - (rc.bottom - rc.top))/2,
			0, 0, SWP_NOSIZE|SWP_NOZORDER|SWP_NOACTIVATE) ;
		SIME_LoadRegistory(kinfo) ;

		id = IDC_CHECK1 ;
		for (i = 0 ; i < 4 ; i++) {
			int flag ;
			flag = GetKeyFlag(kinfo, i) ;
			DOUT("flag:%x\n",flag)
			if (flag & 1) SendDlgItemMessage(hwndDlg,id,BM_SETCHECK,1,0) ;
			if (flag & 2) {
				SendDlgItemMessage(hwndDlg,id+1,BM_SETCHECK,1,0) ;
				if (flag & 4) SendDlgItemMessage(hwndDlg,id+2,BM_SETCHECK,1,0) ;
				if (flag & 8) SendDlgItemMessage(hwndDlg,id+3,BM_SETCHECK,1,0) ;
				EnableWindow(GetDlgItem(hwndDlg,id+2),1) ;
				EnableWindow(GetDlgItem(hwndDlg,id+3),1) ;
			}
			id += 4 ;
		}

		return TRUE ;
	} else if (uMsg == WM_COMMAND) {
		switch(LOWORD(wParam)) {
		case IDM_UPDATE:
			SIME_SaveRegistory(kinfo) ;
			PostMessage(FindWindow(TASKTRAYICONCLASS, TASKTRAYICONNAME),WM_USER,0,0) ;
			return TRUE ;
		case IDOK:
			SIME_SaveRegistory(kinfo) ;
			PostMessage(FindWindow(TASKTRAYICONCLASS, TASKTRAYICONNAME),WM_USER,0,0) ;
			EndDialog(hwndDlg, IDOK) ;
			return TRUE ;
		case IDCANCEL:
			EndDialog(hwndDlg, IDCANCEL) ;
			return TRUE ;
		default:
			{
				int flag,id,x,y ;
				id = LOWORD(wParam) ;
				x = (id - IDC_CHECK1) & 3 ;
				y = (id - IDC_CHECK1) >> 2 ;
				flag = GetKeyFlag(kinfo, y) ;
				switch (x) {
				case 0:
					flag ^= 1 ;
					if (flag & 1) {
						SendDlgItemMessage(hwndDlg,id,BM_SETCHECK,1,0) ;
					} else {
						SendDlgItemMessage(hwndDlg,id,BM_SETCHECK,0,0) ;
					}
					break ;
				case 1:
					flag ^= 2 ;
					if (flag & 2) {
						flag |= 8 ;
						SendDlgItemMessage(hwndDlg,id,BM_SETCHECK,flag&2,0) ;
						SendDlgItemMessage(hwndDlg,id+1,BM_SETCHECK,flag&4,0) ;
						SendDlgItemMessage(hwndDlg,id+2,BM_SETCHECK,flag&8,0) ;
						EnableWindow(GetDlgItem(hwndDlg,id+1),1) ;
						EnableWindow(GetDlgItem(hwndDlg,id+2),1) ;
					} else {
						flag &= 3 ;
						SendDlgItemMessage(hwndDlg,id,BM_SETCHECK,flag&2,0) ;
						SendDlgItemMessage(hwndDlg,id+1,BM_SETCHECK,flag&4,0) ;
						SendDlgItemMessage(hwndDlg,id+2,BM_SETCHECK,flag&8,0) ;
						EnableWindow(GetDlgItem(hwndDlg,id+1),0) ;
						EnableWindow(GetDlgItem(hwndDlg,id+2),0) ;
					}
					break ;
				case 2:
					flag ^= 4 ;
					if (flag & 4) {
						flag &= 0xf - 8 ;
						SendDlgItemMessage(hwndDlg,id,BM_SETCHECK,1,0) ;
						SendDlgItemMessage(hwndDlg,id+1,BM_SETCHECK,0,0) ;
					} else {
						SendDlgItemMessage(hwndDlg,id,BM_SETCHECK,0,0) ;
					}
					break ;
				case 3:
					flag ^= 8 ;
					if (flag & 8) {
						flag &= 0xf - 4 ;
						SendDlgItemMessage(hwndDlg,id-1,BM_SETCHECK,0,0) ;
						SendDlgItemMessage(hwndDlg,id,BM_SETCHECK,1,0) ;
					} else {
						SendDlgItemMessage(hwndDlg,id,BM_SETCHECK,0,0) ;
					}
					break ;
				}
				SetKeyFlag(kinfo, flag, y) ;
			}
			return TRUE ;
		}
	}
	return FALSE ;
}

// ɋNĂ邩ׂ
static BOOL fExist ;
static BOOL __stdcall EnumProc(HWND hWnd, LPARAM lParam) {
	TCHAR buf[32] ;
	if (!GetWindowText(hWnd, buf, 31)) return TRUE ;
	if (2 != CompareString(LOCALE_USER_DEFAULT,0,buf,-1,"SwitchIME Setup",-1)) return TRUE ;
	fExist = TRUE ;
	SetForegroundWindow(hWnd) ;
	return FALSE ;
}
static BOOL CheckExist(void) {
	fExist = FALSE ;
	EnumWindows(EnumProc, 0) ;
	return  fExist ;
}

int __stdcall WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int cmdShow)
{
	MSG msg ;
	// ɋNĂȂI
	if (CheckExist()) return 0;
	return DialogBox(hInstance, MAKEINTRESOURCE(IDD_SIMESETUP),NULL,SetupDialogProc);
}
void MyExeEntry(void) {
	ExitProcess(WinMain(GetModuleHandle(NULL), NULL, NULL, SW_SHOWDEFAULT));
}
