#if 1
#define DOUT(p1,p2)
#else
static void _DOUT(char *format, int value) {
	char buf[256] ;
	wsprintf(buf,format,value) ;
	OutputDebugString(buf) ;
}
#define DOUT(p1,p2) _DOUT(p1,p2);
#endif

char mykey[] = "Software\\BEFiS\\SwitchIME" ;

KEYINFO initData[] = {
	{VK_CONVERT,1+2+8},
	{0,0},
} ;

static void CopyMemoryEx(LPVOID des, LPCVOID src, long len) {
	while (len-->0) *(((LPSTR)des)++) = *(((LPCSTR)src)++) ;
}

static int htoi(char *buf) {
	int ret ;
	for (ret = 0 ; *buf != 0 ; buf++) {
		if ('0' <= *buf && *buf <= '9') {
			ret = (ret << 4) | (*buf - '0') ;
			continue ;
		}
		if ('a' <= *buf && *buf <= 'f') {
			ret = (ret << 4) | (*buf - 'a' + 10) ;
			continue ;
		}
		if ('A' <= *buf && *buf <= 'F') {
			ret = (ret << 4) | (*buf - 'A' + 10) ;
			continue ;
		}
	}
	return ret ;
}

static char hexconv[] = "0123456789ABCDEF" ;

void __stdcall SIME_SaveRegistory(KEYINFO *buf) {
	HKEY hKey ;
	int len, i, j ;
	if (ERROR_SUCCESS != RegCreateKey(HKEY_CURRENT_USER, mykey, &hKey)) return ;
	for (i = 0 ; i < 63 ; i++) {
		char kbuf[16], fbuf[8] ;
		for (j = 0 ; j < 16 ; j++) kbuf[j] = 0 ;
		for (j = 0 ; j <  8 ; j++) fbuf[j] = 0 ;
		if (!buf[i].code) break ;
		fbuf[0] = '0' + (buf[i].flag & 1) ;
		if (buf[i].flag & 2) {
			fbuf[1] = '1' ;
			if (buf[i].flag & 4) {
				fbuf[2] = '1' ;
			} else if (buf[i].flag & 8) {
				fbuf[2] = '2' ;
			} else {
				fbuf[2] = '0' ;
			}
			fbuf[3] = 0 ;
			len = 3 ;
		} else {
			fbuf[1] = '0' ;
			fbuf[2] = 0 ;
			len = 2 ;
		}
		if (buf[i].code & SCAN_FLAG) {
			kbuf[0] = 'S' ;
			kbuf[1] = 'C' ;
			kbuf[2] = '_' ;
			kbuf[3] = hexconv[(buf[i].code >> 12) & 15] ;
			kbuf[4] = hexconv[(buf[i].code >>  8) & 15] ;
			kbuf[5] = hexconv[(buf[i].code >>  4) & 15] ;
			kbuf[6] = hexconv[ buf[i].code        & 15] ;
			kbuf[7] = 0 ;
		} else {
			kbuf[0] = 'V' ;
			kbuf[1] = 'K' ;
			kbuf[2] = '_' ;
			kbuf[3] = hexconv[(buf[i].code >>  4) & 15] ;
			kbuf[4] = hexconv[ buf[i].code        & 15] ;
			kbuf[5] = 0 ;
		}
		RegSetValue(hKey, kbuf, REG_SZ, fbuf, len) ;
	}
	RegCloseKey(hKey) ;
}

void __stdcall SIME_LoadRegistory(KEYINFO *buf) {
	HKEY hKey ;
	int i ;
	if (ERROR_SUCCESS != RegOpenKey(HKEY_CURRENT_USER, mykey, &hKey)) {
		CopyMemoryEx(buf, initData, sizeof(initData)) ;
		return ;
	}
	for (i = 0 ; i < 63 ; i++) {
		char kbuf[16] ;
		char fbuf[8] ;
		LONG len ;
		if (ERROR_SUCCESS != RegEnumKey(hKey, i, kbuf, 15)) break ;
		len = 8 ;
		if (ERROR_SUCCESS != RegQueryValue(hKey, kbuf, fbuf, &len)) break ;
		if (kbuf[0] == 'V' && kbuf[1] == 'K') {
			buf[i].code = htoi(kbuf + 2) ;
		} else if (kbuf[0] == 'S' && kbuf[1] == 'C') {
			buf[i].code = SCAN_FLAG | htoi(kbuf + 2) ;
		} else break ;
		DOUT("code:%x\n", buf[i].code)
		buf[i].flag = (fbuf[0] == '1') ;
		if (fbuf[1] == '1') {
			buf[i].flag |= 2 ;
			if (fbuf[2] == '1') buf[i].flag |= 4 ;
			if (fbuf[2] == '2') buf[i].flag |= 8 ;
		}
		DOUT("flag:%x\n", buf[i].flag)
	}
	buf[i].code = 0 ;
	buf[i].flag = 0 ;
	RegCloseKey(hKey) ;
	return ;
}
