/* cl /LD simesub.c */
#include <windows.h>
#include <imm.h>
#include <tchar.h>

#ifdef _MSC_VER
#pragma comment(linker, "/DEF:simesub.def")
#pragma comment(linker, "/DLL")
#pragma comment(linker, "/DEFAULTLIB:imm32.lib")
#pragma comment(linker, "/DEFAULTLIB:user32.lib")
#pragma comment(linker, "/HEAP:0 /STACK:0x1000")
#pragma comment(linker, "/ENTRY:MyDllEntry")
#pragma data_seg("mydata")
#pragma bss_seg("mydata")
#pragma const_seg("mydata")
#pragma comment(linker, "/SECTION:mydata,RWS")
#if _MSC_VER >= 1200
#pragma comment(linker, "/OPT:NOWIN98")
/* #pragma comment(linker, "/WS:AGGRESSIVE") */
#endif
#endif

#include "simereg.h"

#if 1
#define GETFOCUS GetFocus
#elif 0
#define GETFOCUS GetActiveWindow
#elif 0
#define GETFOCUS GetForegroundWindow
#endif

#if 1
#define DOUT(p1,p2)
#else
static void _DOUT(char *format, int value)
{
	char buf[256];
	wsprintf(buf,format,value);
	OutputDebugString(buf);
}
#define DOUT(p1,p2) _DOUT(p1,p2);
#endif

/* m蕶𓾂 */
static int GetIMEMode(void)
{
	HWND hwnd;
	HIMC himc;
	LONG ret;
	hwnd = GETFOCUS();
	if (hwnd == NULL) return -1;
	himc = ImmGetContext(hwnd);
	if (ImmGetOpenStatus(himc))
	{
		ret = ImmGetCompositionString(himc, GCS_COMPSTR, NULL, 0);
		ret = ret > 0 ? ret : 0;
	}
	else
	{
		ret = -1;
	}
	ImmReleaseContext(hwnd, himc);
	return ret;
}

/* IMEӰނύX */
static void SetIMEMode(BOOL mode)
{
	HWND hwnd;
	HIMC himc;
	hwnd = GETFOCUS();
	if (hwnd == NULL) return;
	himc = ImmGetContext(hwnd);
	ImmSetOpenStatus(himc, mode);
	ImmReleaseContext(hwnd, himc);
	return;
}

/* m蕶m肷 */
static void SetIMEConvert(void)
{
	HWND hwnd;
	HIMC himc;
	hwnd = GETFOCUS();
	if (hwnd == NULL) return;
	himc = ImmGetContext(hwnd);
	ImmNotifyIME(himc, NI_COMPOSITIONSTR, CPS_COMPLETE, 0);
	ImmReleaseContext(hwnd, himc);
	return;
}

LRESULT CALLBACK KeyBoardHookProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	static KEYINFO kinfo[65] = {{0,0},};
	static HHOOK hHook = 0;
	static int lock = 0;
	int mode, i;
	if (!lock) switch (nCode)
	{
		case 0x7fff:
			/*  */
			if (wParam == 0xffffffff)
			{
				hHook = (HHOOK)lParam;
			}
			else
			{
				lock++;
				kinfo[wParam&63].code = lParam;
				kinfo[wParam&63].flag = (wParam >> 8) & 15;
				kinfo[(wParam&63)+1].code = 0;
				lock--;
			}
			return 1;
		case HC_ACTION:
			if ((lParam & 0xc0000000) != 0) break;	/* KEYDOWN̂ݏ */
			DOUT("_%d_\n",wParam)
			for (i = 0; i < 63; i++)
			{
				if (kinfo[i].code == 0)
					break;
				else if (kinfo[i].code & SCAN_FLAG)
				{
					if ((kinfo[i].code & 511) != ((lParam >> 16) & 511))
						continue;
				}
				else if (kinfo[i].code == wParam)
				{
				}
				else
					continue;
				if (kinfo[i].flag == 0) break;			/* 䂵Ȃ */
		 		mode = GetIMEMode();					/* m蕶 */
				if (mode < 0)							/* IMEIt */
				{
					if (kinfo[i].flag & 1)
					{
						SetIMEMode(TRUE);				/* IMEI */
						return 1;
					}
					break;
				}
				if ((kinfo[i].flag & 2) == 0) break;
				if (mode == 0)							/* m蕶Ȃ */
				{
					SetIMEMode(FALSE);					/* IMEIt */
					return 1;
				}
				if (kinfo[i].flag & 8) break;			/* IMEɂ܂ */
				if (kinfo[i].flag & 4) SetIMEConvert();	/* m肷 */
				SetIMEMode(FALSE);						/* IMEIt */
				return 1;
			}
			break;
	}
	if (!hHook) return 0;
	return CallNextHookEx(hHook, nCode, wParam, lParam);
}

BOOL WINAPI MyDllEntry(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	switch (fdwReason)
	{
		case DLL_PROCESS_ATTACH:
			break;
		case DLL_PROCESS_DETACH:
			break;
	}
	return TRUE;
}
